<?php

namespace TYPO3\Test\Tests;
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class \TYPO3\Test\Domain\Model\A.
 *
 * @version $Id$
 * @copyright Copyright belongs to the respective authors
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 * @package TYPO3
 * @subpackage Test
 *
 */
class ATest extends \TYPO3\CMS\Extbase\Tests\Unit\BaseTestCase {
	/**
	 * @var \TYPO3\Test\Domain\Model\A
	 */
	protected $fixture;

	public function setUp() {
		$this->fixture = new \TYPO3\Test\Domain\Model\A();
	}

	public function tearDown() {
		unset($this->fixture);
	}

	/**
	 * @test
	 */
	public function getBReturnsInitialValueForB() { 
		$newObjectStorage = new \TYPO3\CMS\Extbase\Persistence\Generic\ObjectStorage();
		$this->assertEquals(
			$newObjectStorage,
			$this->fixture->getB()
		);
	}

	/**
	 * @test
	 */
	public function setBForObjectStorageContainingBSetsB() { 
		$b = new \TYPO3\Test\Domain\Model\B();
		$objectStorageHoldingExactlyOneB = new \TYPO3\CMS\Extbase\Persistence\Generic\ObjectStorage();
		$objectStorageHoldingExactlyOneB->attach($b);
		$this->fixture->setB($objectStorageHoldingExactlyOneB);

		$this->assertSame(
			$objectStorageHoldingExactlyOneB,
			$this->fixture->getB()
		);
	}
	
	/**
	 * @test
	 */
	public function addBToObjectStorageHoldingB() {
		$b = new \TYPO3\Test\Domain\Model\B();
		$objectStorageHoldingExactlyOneB = new \TYPO3\CMS\Extbase\Persistence\Generic\ObjectStorage();
		$objectStorageHoldingExactlyOneB->attach($b);
		$this->fixture->addB($b);

		$this->assertEquals(
			$objectStorageHoldingExactlyOneB,
			$this->fixture->getB()
		);
	}

	/**
	 * @test
	 */
	public function removeBFromObjectStorageHoldingB() {
		$b = new \TYPO3\Test\Domain\Model\B();
		$localObjectStorage = new \TYPO3\CMS\Extbase\Persistence\Generic\ObjectStorage();
		$localObjectStorage->attach($b);
		$localObjectStorage->detach($b);
		$this->fixture->addB($b);
		$this->fixture->removeB($b);

		$this->assertEquals(
			$localObjectStorage,
			$this->fixture->getB()
		);
	}
	
}
?>